/********************************************************************************
 * Copyright (C) 2017 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import { MessageService, CommandRegistry } from '@theia/core/lib/common';
import { Window, OutputChannel, MessageActionItem, MessageType } from 'monaco-languageclient/lib/services';
export declare class WindowImpl implements Window {
    private canAccessOutput;
    protected static readonly NOOP_CHANNEL: OutputChannel;
    protected readonly messageService: MessageService;
    protected readonly commandRegistry: CommandRegistry;
    showMessage<T extends MessageActionItem>(type: MessageType, message: string, ...actions: T[]): Thenable<T | undefined>;
    createOutputChannel(name: string): OutputChannel;
}
//# sourceMappingURL=window-impl.d.ts.map